;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;										;;
;;			  Steady Hand				;;
;;			  ===========				;;
;;										;;
;;			 By Forklift_Fred			;;
;;	 For SoCodor's Wednesday Workshop	;;
;;		#155 (11/06/08 - 18/06/08)		;;
;;										;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AppTitle "Steady Hand"

Graphics 640,480,32,2
SetBuffer BackBuffer()

Dim scancode$(255)
SetScanCodes()

Type frames
	Field name$
	Field image
	Field thumb
End Type

Global frame=LoadImage("line.png")
Global base=CreateImage(640,480)
MakeBase()

If frame=0 Then MakeFrame()
Global loop1=CreateImage(50,50)
Global loop=CreateImage(50,50,18)
MakeLoop()

Color 255,255,255

Global starttime=MilliSecs()
Global deltatime=0
Global life=15
Global buzz=life

Global maxlives=3
Global lives=maxlives
Global timelimit=60
reset=False
.options
ShowPointer
AppTitle "Steady Hand - Menu"
While Not KeyHit(1)
	mx=MouseX()
	my=MouseY()
	md1=MouseHit(1)
	md2=MouseHit(2)
	ClsColor 128,128,255
	Cls
	Color 255,255,128
	Text 320,50,"Steady Hand!",1
	Text 321,50,"Steady Hand!",1
	Text 320,50,"____________",1
	Text 320,51,"____________",1
	Text 320,100,"Buzz Factor - Default 15",1
	Text 320,140,"Lives - Default 3",1
	Text 320,180,"Time Limit - Default 60 seconds",1
	Text 320,400,"Click numbers to change values - LEFT to decrease, RIGHT to increase",1
	Color 200,32,32
	life=life+Click(320,118,life,mx,my,md1,md2)
	maxlife=maxlife+Click(320,158,maxlives,mx,my,md1,md2)
	timelimit=timelimit+Click(320,198,timelimit,mx,my,md1,md2)
	st=Abs(Click(320,270,"Start",mx,my,md1,md2))
	lw=Abs(Click(320,290,"Load wire",mx,my,md1,md2))
	nw=Abs(Click(320,310,"New wire",mx,my,md1,md2))
	ew=Abs(Click(320,330,"Edit a wire",mx,my,md1,md2))
	If st Then Goto start
	If lw Then OpenFrame():Goto start
	If nw Then MakeFrame(1):Goto start
	If ew Then MakeFrame():Goto start
	Flip
Wend
End

.start
;[Block]	Main Game
AppTitle "Steady Hand - Play!"
HidePointer
MoveMouse 50,400
MX_old=50
MY_old=400
f=0

starttime=MilliSecs()
deltatime=0
buzz=life

While Not KeyHit(1)
	If KeyHit(24) Then OpenFrame(): Goto start	; O Open
	If KeyHit(31) Then SaveFrame(): Goto start	; S Save
	If KeyHit(49) Then MakeFrame(1): Goto start	; N New
	If KeyHit(18) Then MakeFrame(): Goto start	; E Edit
	MZS=MouseZSpeed()
	MX=MouseX()
	MY=MouseY()
	If MY>380 Then
		If MX>40 And MX<60 Then			; Over start post
			starttime=MilliSecs()-deltatime
			buzz=buzz+1
			If buzz>life Then buzz=life
		Else If MX>580 And MX<600 Then	; Over finish post
			Finish(1)
			Goto options
		Else
			deltatime=MilliSecs()-starttime
		End If
	Else
		deltatime=MilliSecs()-starttime
	End If
	If deltatime=>timelimit*1000 Then Finish():Goto options
	If MZS>0 Then f=f-1
	If MZS<0 Then f=f+1
	If f>17 Then f=0
	If f<0 Then f=17
	If ImagesCollide(loop,mx,my,f,frame,0,0,0) 
		MX=MX_old
		MY=MY_old
		f=f_old
		MoveMouse MX,MY
		If MY<355 Then
			ClsColor 250,250,255
			buzz=buzz-1
			If buzz<0 Then
				buzz=0
				For ii=100 To 0 Step -1
					DrawImage frame,0,0
					ProgressBar(0,460,640,19,ii,100)
					Color 0,0,0
					Text 320,400,"Resetting...",1
					Text 321,400,"Resetting...",1
					Flip
				Next
				lives=lives-1
				If lives=0 Then
					Finish(0)
					Goto options
				Else
					Goto start
				End If
			End If
		End If
	Else
		If buzz>0 Then ClsColor 0,0,0
		MX_old=MX
		MY_old=MY
		f_old=f
	End If
	Cls
	DrawImage frame,0,0
	DrawImage loop,MX,MY,f
	Color 255,255,255
	Text 0,10,deltatime/1000
	Text 0,25,lives
	ProgressBar(0,0,640,10,buzz,life,2)
	Flip
Wend
Goto options
;[End block]


Function Click(x,y,strng$,mx,my,md1,md2)
	Text x,y,strng,1
	Text x+1,y,strng,1
	w=StringWidth(strng$)
	h=StringHeight(strng$)
	If mx>x-w And mx<x+w And my>y-h And my<y+h Then Return md2-md1
End Function

Function ProgressBar(x,y,width,height,current#,total#,output=0)
	progress#=current/total
	length=width*progress
	
	Select output
		Case 1	; Fraction
			reading$=Int(current)+"/"+Int(total)
		Case 2	; Percentage
			reading$=progress*100+" %"
		Case 3	; Count
			reading$=Int(current)
		Case 4	; Count of total
			reading$=Int(current)+" of "+Int(total)
	End Select
	
	Color 255-((255/100)*progress*100),(255/100)*progress*100,0	; Text Colour
	Text x+width/2,y+height,reading$,1,0
	
	Color 0,255,0	; Border Colour
	Rect x,y,width,height,0
	
	Color 255-((255/100)*progress*100),(255/100)*progress*100,0	; Bar Colour
	Rect x+1,y+1,length-2,height-2,1
	
End Function

Function OpenFrame()
	AppTitle "Steady Hand - Open a wire"
	ShowPointer
	dir$=ReadDir(CurrentDir()+"/frames")
	Delete Each frames
	
	If FileType(CurrentDir$()+"\frames")=2 Then
		Repeat
			file$=NextFile(dir$)
			If Lower(Right(file$,3))="bmp" Or Lower(Right(file$,3))="png" Then
				frames.frames=New frames
				frames\name$=Mid$(file$,1,Len(file$)-4)
				frames\image=LoadImage("frames/"+file$)
				frames\thumb=CopyImage(frames\image)
				ScaleImage frames\thumb,0.20,0.20
				MaskImage frames\thumb,255,0,255
			End If
			If(file$="") Then Exit
		Forever
	Else
		skip=True
	End If
	
	ClsColor 128,255,128
	While Not KeyHit(1)
		Cls
		Color 64,128,64
		For y=0 To 2
			For x=0 To 2
				Rect 78+(x*176),38+(y*131),128,96
			Next
		Next
		Color 200,255,200
		For y=0 To 2
			For x=0 To 2
				Rect 82+(x*176),42+(y*131),128,96
			Next
		Next
		Color 100,200,100
		For y=0 To 2
			For x=0 To 2
				Rect 80+(x*176),40+(y*131),128,96
			Next
		Next
		If skip Then
			Color 255,0,0
			Rect 150,150,340,180
			Color 255,255,255
			Text 321,240,"No files found",1,1
			Text 320,240,"No files found",1,1
			Flip
			Delay 1500
			Exit
		Else
			frames.frames=First frames
			For y=0 To 2
				For x=0 To 2
					If RectsOverlap(MouseX(),MouseY(),1,1,80+(x*176),40+(y*131),128,116) Then
						MaskImage frames\thumb,0,0,0
						Color 255,0,0
						Rect 75+(x*176),35+(y*131),138,106,0
						If MouseHit(1) Then
							frame=CopyImage(frames\image)
							load=True
							Color 255,0,0
							Rect 75+(x*176),35+(y*131),138,106
						End If
						Color 255,0,0
						Text 144+(x*176),141+(y*131),frames\name$,1
					Else
						MaskImage frames\thumb,255,0,255
						Color 64,128,64
						Text 144+(x*176),141+(y*131),frames\name$,1
					End If
					
					DrawImage frames\thumb,80+(x*176),40+(y*131)
					frames.frames=After frames
					If frames.frames=Null Then Exit
				Next
				If frames.frames=Null Then Exit
			Next
			Flip
			If load=True Then Exit
		End If
	Wend
End Function

Function SaveFrame()
	AppTitle "Steady Hand - Save the wire"
	ClsColor 255,128,128
	Color 255,255,255
	thumb=CopyImage(frame)
	ScaleImage(thumb,0.20,0.20)
	MidHandle thumb
	MaskImage thumb,255,0,255
	While (Not KeyDown(28)) And (Not KeyDown(156))	; Until ENTER is pressed...
		Cls
		DrawImage thumb,320,240
		time=MilliSecs()
		If time=>time_n Then
			time_n=time+300
			blink=Not blink
		End If
		
		Text 10,40,"  Enter a name to save wire as: "+wire_name$
		x=StringWidth(wire_name$)+1
		If blink Then
			Rect x+264,40,8,13				; And draw the cursor in the currect position
		End If
		
		If KeyHit(14) Then wire_name$=Mid$(wire_name$,1,Len(wire_name$)-1)	; Backspace deletes the last letter of the name
		For i=2 To 86						; Otherwise loop through the keyboard...
			If KeyHit(i) Then wire_name$=wire_name$+scancode$(i)								; ... and add it on
		Next
		Flip
		If KeyHit(1) Then quit=True
		If quit Then Exit
	Wend
	If Not quit Then
		If FileType(CurrentDir$()+"\frames")=0 Then CreateDir(CurrentDir$()+"\frames")
		SaveBuffer ImageBuffer(frame),"frames/"+wire_name$+".bmp"
	Else
		ClsColor 255,0,0
		Cls
		Text 320,240,"FILE NOT SAVED!",1,1
		Text 321,240,"FILE NOT SAVED!",1,1
		Flip
		Delay 1500
	End If
	FlushKeys
End Function

Function MakeBase()
	SetBuffer ImageBuffer(base)
	
	g#=255
	b#=0
	r#=255
	For x=0 To 21
		Color r,0,0
		Rect 580+x,380,1,81,1
		Color 0,g,b
		Rect 40+x,380,1,81,1
		g=g-4.0454545
		b=b+3.6181818
		r=r-5
	Next
	
	r#=79
	g#=53
	b#=17
	
	For y=0 To 19
		Color r,g,b
		Rect 0,460+y,640,1,1
		r=r-1.25
		g=g-0.3
		b=b+1.4
	Next
	
	Color 255,255,255
	Rect 48,375,5,5,1
	Rect 588,375,5,5,1
	SetBuffer BackBuffer()
End Function

Function MakeLoop()
	SetBuffer ImageBuffer(loop1)
	Color 0,0,255
	Oval 0,0,50,50,1
	Color 0,0,0
	Oval 4,4,42,42,1
	Rect 6,0,38,50,1
	
	MidHandle loop1
	SetBuffer BackBuffer()
	
	For f=0 To 17
		RotateImage loop1,10*f
		SetBuffer ImageBuffer(loop,f)
		DrawImage loop1,25,25
		loop1=CreateImage(50,50)
		MidHandle loop1
		CopyRect 0,0,50,50,0,0,ImageBuffer(loop,0),ImageBuffer(loop1)
	Next
	MidHandle loop
	SetBuffer BackBuffer()
End Function

Function Finish(win=0)
	Cls
	For ii=300 To 0 Step -1
		DrawImage frame,0,0
		Color 200-(win*128),0+(win*200),0
		Rect 100,100,440,280
		If Not win Then
			message1$="You failed!"
			If deltatime=>timelimit*1000 Then message2$="You were out of time!"
			If lives=0 Then message2$="You have used all your lives!"
		Else
			message1$="Congratulations! You completed in "+(deltatime/1000)+" seconds"
			message2$="after "+(maxlives-lives+1)+" attempt"
			If maxlives-lives+1>1 Then message2$=message2$+"s"
		End If
		Color 0,0,0
		Text 320,230,message1$,1,1
		Text 320,250,message2$,1,1
		ProgressBar(0,460,640,19,ii,100)
		Color 0,0,0
		Text 320,400,"Please wait...",1
		Text 321,400,"Please wait...",1
		Flip
	Next
	lives=maxlives
	reset=True
End Function

Function MakeFrame(n=0)
	AppTitle "Steady Hand - Edit mode"
	FlushMouse
	If frame=0 Or n=1 Then frame=CopyImage(base)
	
	HidePointer
	SetBuffer BackBuffer()
	MX_old=MouseX()
	MY_old=MouseY()
	MD1=0
	MD2=0
	Delay 500
	FlushMouse
	While Not KeyHit(1)
		If KeyHit(24) Then OpenFrame():AppTitle "Steady Hand - Edit mode"	; O Open
		If KeyHit(31) Then SaveFrame():AppTitle "Steady Hand - Edit mode"	; S Save
		If KeyHit(49) Then frame=CopyImage(base)							; N New
		ClsColor 0,128,0
		Cls
		MD1=MouseDown(1)
		MD2=MouseDown(2)
		MX=MouseX()
		MY=MouseY()
		MZS=MouseZSpeed()
		If MZS>0 Then s=s+1
		If MZS<0 Then s=s-1
		If MD1 Or MD2 Then
			SetBuffer ImageBuffer(frame)
			Color 255*MD1,255*MD1,255*MD1
			If MX>MX_old Then
				MX1#=MX_old
				MX2#=MX
			Else
				MX1#=MX
				MX2#=MX_old
			End If
			If MY>MY_old Then
				MY1#=MY_old
				MY2#=MY
			Else
				MY1#=MY
				MY2#=MY_old
			End If
			dx#=MX2-MX1
			dy#=MY2-MY1
			Oval MX1+(dx/2),MY1+(dy/2),5,5,1
			Oval MX_old,MY_old,5,5,1
			Oval MX,MY,5,5,1
			DrawImage base,0,0
			SetBuffer BackBuffer()
		End If
		Color 10,100,255
		DrawImage frame,0,0
		Oval MX,MY,5,5,1
		Flip
		MX_old=MX
		MY_old=MY
	Wend
	FlushKeys()
End Function


Function SetScanCodes()
	For i=0 To 255
		scancode$(i)=""
	Next
	scancode$(02)="1"
	scancode$(03)="2"
	scancode$(04)="3"
	scancode$(05)="4"
	scancode$(06)="5"
	scancode$(07)="6"
	scancode$(08)="7"
	scancode$(09)="8"
	scancode$(10)="9"
	scancode$(11)="0"
	scancode$(12)="-"
	scancode$(16)="q"
	scancode$(17)="w"
	scancode$(18)="e"
	scancode$(19)="r"
	scancode$(20)="t"
	scancode$(21)="y"
	scancode$(22)="u"
	scancode$(23)="i"
	scancode$(24)="o"
	scancode$(25)="p"
	scancode$(26)="["
	scancode$(27)="]"
	scancode$(30)="a"
	scancode$(31)="s"
	scancode$(32)="d"
	scancode$(33)="f"
	scancode$(34)="g"
	scancode$(35)="h"
	scancode$(36)="j"
	scancode$(37)="k"
	scancode$(38)="l"
	scancode$(39)=";"
	scancode$(40)="'"
	scancode$(41)="`"
	scancode$(43)="#"
	scancode$(44)="z"
	scancode$(45)="x"
	scancode$(46)="c"
	scancode$(47)="v"
	scancode$(48)="b"
	scancode$(49)="n"
	scancode$(50)="m"
	scancode$(51)=","
	scancode$(52)="."
	scancode$(71)="7"
	scancode$(72)="8"
	scancode$(73)="9"
	scancode$(74)="-"
	scancode$(75)="4"
	scancode$(76)="5"
	scancode$(77)="6"
	scancode$(78)="+"
	scancode$(79)="1"
	scancode$(80)="2"
	scancode$(81)="3"
	scancode$(82)="0"
End Function

;~IDEal Editor Parameters:
;~F#AE#C8#11F#14C#16E#185#1DF
;~C#Blitz3D